Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.netlib.lapack
Class SLASD7

    java.lang.Object
      org.netlib.lapack.SLASD7

    public class SLASD7

extends java.lang.Object

    SLASD7 is a simplified interface to the JLAPACK routine slasd7.
    This interface converts Java-style 2D row-major arrays into
    the 1D column-major linearized arrays expected by the lower
    level JLAPACK routines.  Using this interface also allows you
    to omit offset and leading dimension arguments.  However, because
    of these conversions, these routines will be slower than the low
    level ones.  Following is the description from the original Fortran
    source.  Contact seymour@cs.utk.edu with any questions.

     *     ..
     *
     *  Purpose
     *  =======
     *
     *  SLASD7 merges the two sets of singular values together into a single

     *  sorted set. Then it tries to deflate the size of the problem. There
     *  are two ways in which deflation can occur:  when two or more singular
     *  values are close together or if there is a tiny entry in the Z
     *  vector. For each such occurrence the order of the related
     *  secular equation problem is reduced by one.
     *
     *  SLASD7 is called from SLASD6.
     *
     *  Arguments
     *  =========
     *
     *  ICOMPQ  (input) INTEGER
     *          Specifies whether singular vectors are to be computed
     *          in compact form, as follows:
     *          = 0: Compute singular values only.
     *          = 1: Compute singular vectors of upper
     *               bidiagonal matrix in compact form.
     *
     *  NL     (input) INTEGER
     *         The row dimension of the upper block. NL >= 1.
     *
     *  NR     (input) INTEGER
     *         The row dimension of the lower block. NR >= 1.
     *
     *  SQRE   (input) INTEGER
     *         = 0: the lower block is an NR-by-NR square matrix.
     *         = 1: the lower block is an NR-by-(NR+1) rectangular matrix.
     *
     *         The bidiagonal matrix has
     *         N = NL + NR + 1 rows and
     *         M = N + SQRE >= N columns.
     *
     *  K      (output) INTEGER
     *         Contains the dimension of the non-deflated matrix, this is
     *         the order of the related secular equation. 1 <= K <=N.
     *
     *  D      (input/output) REAL array, dimension ( N )
     *         On entry D contains the singular values of the two submatrices
     *         to be combined. On exit D contains the trailing (N-K) updated

     *         singular values (those which were deflated) sorted into
     *         increasing order.
     *
     *  Z      (output) REAL array, dimension ( M )
     *         On exit Z contains the updating row vector in the secular
     *         equation.
     *
     *  ZW     (workspace) REAL array, dimension ( M )
     *         Workspace for Z.
     *
     *  VF     (input/output) REAL array, dimension ( M )
     *         On entry, VF(1:NL+1) contains the first components of all
     *         right singular vectors of the upper block; and VF(NL+2:M)
     *         contains the first components of all right singular vectors
     *         of the lower block. On exit, VF contains the first components

     *         of all right singular vectors of the bidiagonal matrix.
     *
     *  VFW    (workspace) REAL array, dimension ( M )
     *         Workspace for VF.
     *
     *  VL     (input/output) REAL array, dimension ( M )
     *         On entry, VL(1:NL+1) contains the  last components of all
     *         right singular vectors of the upper block; and VL(NL+2:M)
     *         contains the last components of all right singular vectors
     *         of the lower block. On exit, VL contains the last components
     *         of all right singular vectors of the bidiagonal matrix.
     *
     *  VLW    (workspace) REAL array, dimension ( M )
     *         Workspace for VL.
     *
     *  ALPHA  (input) REAL
     *         Contains the diagonal element associated with the added row.
     *
     *  BETA   (input) REAL
     *         Contains the off-diagonal element associated with the added
     *         row.
     *
     *  DSIGMA (output) REAL array, dimension ( N )
     *         Contains a copy of the diagonal elements (K-1 singular values

     *         and one zero) in the secular equation.
     *
     *  IDX    (workspace) INTEGER array, dimension ( N )
     *         This will contain the permutation used to sort the contents of
     *         D into ascending order.
     *
     *  IDXP   (workspace) INTEGER array, dimension ( N )
     *         This will contain the permutation used to place deflated
     *         values of D at the end of the array. On output IDXP(2:K)
     *         points to the nondeflated D-values and IDXP(K+1:N)
     *         points to the deflated singular values.
     *
     *  IDXQ   (input) INTEGER array, dimension ( N )
     *         This contains the permutation which separately sorts the two
     *         sub-problems in D into ascending order.  Note that entries in

     *         the first half of this permutation must first be moved one
     *         position backward; and entries in the second half
     *         must first have NL+1 added to their values.
     *
     *  PERM   (output) INTEGER array, dimension ( N )
     *         The permutations (from deflation and sorting) to be applied
     *         to each singular block. Not referenced if ICOMPQ = 0.
     *
     *  GIVPTR (output) INTEGER
     *         The number of Givens rotations which took place in this
     *         subproblem. Not referenced if ICOMPQ = 0.
     *
     *  GIVCOL (output) INTEGER array, dimension ( LDGCOL, 2 )
     *         Each pair of numbers indicates a pair of columns to take place
     *         in a Givens rotation. Not referenced if ICOMPQ = 0.
     *
     *  LDGCOL (input) INTEGER
     *         The leading dimension of GIVCOL, must be at least N.
     *
     *  GIVNUM (output) REAL array, dimension ( LDGNUM, 2 )
     *         Each number indicates the C or S value to be used in the
     *         corresponding Givens rotation. Not referenced if ICOMPQ = 0.
     *
     *  LDGNUM (input) INTEGER
     *         The leading dimension of GIVNUM, must be at least N.
     *
     *  C      (output) REAL
     *         C contains garbage if SQRE =0 and the C-value of a Givens
     *         rotation related to the right null space if SQRE = 1.
     *
     *  S      (output) REAL
     *         S contains garbage if SQRE =0 and the S-value of a Givens
     *         rotation related to the right null space if SQRE = 1.
     *
     *  INFO   (output) INTEGER
     *         = 0:  successful exit.
     *         < 0:  if INFO = -i, the i-th argument had an illegal value.
     *
     *  Further Details
     *  ===============
     *
     *  Based on contributions by
     *     Ming Gu and Huan Ren, Computer Science Division, University of
     *     California at Berkeley, USA
     *
     *  =====================================================================
     *
     *     .. Parameters ..

Constructor Summary
`SLASD7()`

Method Summary
`static void` | `SLASD7(int icompq, int nl, int nr, int sqre, intW k, float[] d, float[] z, float[] zw, float[] vf, float[] vfw, float[] vl, float[] vlw, float alpha, float beta, float[] dsigma, int[] idx, int[] idxp, int[] idxq, int[] perm, intW givptr, int[][] givcol, float[][] givnum, floatW c, floatW s, intW info)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SLASD7

    public SLASD7()

Method Detail

### SLASD7

    public static void SLASD7(int icompq,
                              int nl,
                              int nr,
                              int sqre,
                              intW k,
                              float[] d,
                              float[] z,
                              float[] zw,
                              float[] vf,
                              float[] vfw,
                              float[] vl,
                              float[] vlw,
                              float alpha,
                              float beta,
                              float[] dsigma,
                              int[] idx,
                              int[] idxp,
                              int[] idxq,
                              int[] perm,
                              intW givptr,
                              int[][] givcol,
                              float[][] givnum,
                              floatW c,
                              floatW s,
                              intW info)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD